Copyright updates:
[exim.git] / src / scripts / lookups-Makefile
1 #! /bin/sh
2
3 # Copyright (c) The Exim Maintainers 1995 - 2021
4
5 # We turn the configure-built build-$foo/lookups/Makefile.predynamic into Makefile
6
7 # We always re-exec ourselves at least once, because it's the cleanest and
8 # most portable way to turn on various features we expect of POSIX sh.
9 if [ -z "$EXIM_LOOKUP_MAKEFILE_ADJUSTED" ]
10 then
11   SHELL=/bin/sh
12   EXIM_LOOKUP_MAKEFILE_ADJUSTED=yes
13   export EXIM_LOOKUP_MAKEFILE_ADJUSTED
14
15   # Solaris sh and tr are problematic until we get xpg4 variants
16   if [ -x /usr/xpg4/bin/sh ]
17   then
18     PATH="/usr/xpg4/bin:$PATH"
19     export PATH
20     SHELL=/usr/xpg4/bin/sh
21     export SHELL
22   fi
23
24   # IRIX uses /bin/ksh for sh but in a compatibility mode unless $_XPG == 1,
25   # where said compatibility mode disables $(...)
26   _XPG=1
27   export _XPG
28
29   # We need the _right_ tr, so must do that first; but if a shell which
30   # we're more confident is sane is available, let's try that.  Mostly,
31   # the problem is that "local" is not actually in "the" standard, it's
32   # just in every not-insane shell.  Though arguably, there are no shells
33   # with POSIX-ish syntax which qualify as "not insane".
34   for b in /bin/dash /bin/bash /usr/local/bin/bash
35   do
36     if [ -x "$b" ]
37     then
38       SHELL="$b"
39       break
40     fi
41   done
42   # if we get a report of a system with zsh but not bash, we can add that
43   # to the list, but be sure to enable sh_word_split in that case.
44
45   exec "$SHELL" "$0" "$@"
46 fi
47
48 input=lookups/Makefile.predynamic
49 target=lookups/Makefile.postdynamic
50 defs_source=Makefile-t
51 tag_marker='MAGIC-TAG-MODS-OBJ-RULES-GO-HERE'
52
53 tab='   '
54
55 # We rely on tr(1) for translating case below.  Some people export
56 # values of LC_CTYPE and LC_COLLATE which apparently break our assumptions.
57 # We're a script expecting certain output based on known inputs and not dealing
58 # with UTF8, so we should be safe doingthis:
59 LC_ALL=C
60 export LC_ALL
61
62 if [ -f "$defs_source" ]
63 then
64   :
65   # we are happy
66 else
67   echo >&2 "$0: ERROR: MISSING FILE '${defs_source}'"
68   echo >&2 "$0: SHOULD HAVE BEEN CALLED FROM scripts/Configure-Makefile"
69   exit 1
70 fi
71
72 # nb: do not permit leading whitespace for this, as CFLAGS_DYNAMIC is exported
73 # to the lookups subdir via a line with leading whitespace which otherwise
74 # matches
75 if grep -q "^CFLAGS_DYNAMIC[ $tab?:]*=" "$defs_source"
76 then
77   # we have a definition, we're good to go
78   echo >&2 ">>> Creating lookups/Makefile for building dynamic modules"
79   enable_dynamic=yes
80 else
81   echo >&2 ">>> Creating lookups/Makefile without dynamic module support"
82   enable_dynamic=''
83   # We always do something now, since there should always be a lookup,
84   # and now we need to run in order to put the OBJ=$(OBJ)+ rules in.  So we
85   # continue on.
86 fi
87
88 # For the want_ checks, we need to let the user override values from the make
89 # command-line, not just check the Makefile.
90
91 want_dynamic() {
92   local dyn_name="$1"
93   local re="LOOKUP_${dyn_name}[ $tab]*=[ $tab]*2"
94   env | grep -q "^$re"
95   if [ $? -eq 0 ]; then return 0; fi
96   grep -q "^[ $tab]*$re" "$defs_source"
97 }
98
99 want_at_all() {
100   local want_name="$1"
101   local re="LOOKUP_${want_name}[ $tab]*=[ $tab]*."
102   env | grep -q "^$re"
103   if [ $? -eq 0 ]; then return 0; fi
104   grep -q "^[ $tab]*$re" "$defs_source"
105 }
106
107 # Adapted want_at_all above to work for EXPERIMENTAL features
108 want_experimental() {
109   local want_name="$1"
110   local re="EXPERIMENTAL_${want_name}[ $tab]*=[ $tab]*."
111   env | grep -q "^$re"
112   if [ $? -eq 0 ]; then return 0; fi
113   grep -q "^[ $tab]*$re" "$defs_source"
114 }
115
116 # The values of these variables will be emitted into the Makefile.
117
118 MODS=""
119 OBJ=""
120
121 emit_module_rule() {
122   local lookup_name="$1"
123   local mod_name pkgconf
124   if [ "${lookup_name%:*}" = "$lookup_name" ]
125   then
126     # Square brackets are redundant but benign for POSIX compliant tr,
127     # however Solaris /usr/bin/tr requires them. Sometimes Solaris
128     # gets installed without a complete set of xpg4 tools, sigh.
129     mod_name=$(echo $lookup_name | tr [A-Z] [a-z])
130   else
131     mod_name="${lookup_name#*:}"
132     lookup_name="${lookup_name%:*}"
133   fi
134
135   if want_dynamic "$lookup_name"
136   then
137     if [ -z "$enable_dynamic" ]; then
138       echo >&2 "Missing CFLAGS_DYNAMIC prevents building dynamic $lookup_name"
139       exit 1
140     fi
141     MODS="${MODS} ${mod_name}.so"
142     pkgconf=$(grep "^LOOKUP_${lookup_name}_PC" "$defs_source")
143     if [ $? -eq 0 ]; then
144       pkgconf=$(echo $pkgconf | sed 's/^.*= *//')
145       echo "LOOKUP_${mod_name}_INCLUDE = $(pkg-config --cflags $pkgconf)"
146       echo "LOOKUP_${mod_name}_LIBS = $(pkg-config --libs $pkgconf)"
147     else
148       grep "^LOOKUP_${lookup_name}_" "$defs_source"
149       echo "LOOKUP_${mod_name}_INCLUDE = \$(LOOKUP_${lookup_name}_INCLUDE)"
150       echo "LOOKUP_${mod_name}_LIBS = \$(LOOKUP_${lookup_name}_LIBS)"
151     fi
152   elif want_at_all "$lookup_name"
153   then
154     OBJ="${OBJ} ${mod_name}.o"
155   fi
156 }
157
158 rm -f "$target"
159 exec 5>&1
160 exec > "$target"
161
162 sed -n "1,/$tag_marker/p" < "$input"
163
164 for name_mod in \
165     CDB DBM:dbmdb DNSDB DSEARCH IBASE JSON LMDB LSEARCH MYSQL NIS NISPLUS ORACLE \
166     PASSWD PGSQL REDIS SQLITE TESTDB WHOSON
167 do
168   emit_module_rule $name_mod
169 done
170
171 if want_at_all LDAP
172 then
173   OBJ="${OBJ} ldap.o"
174 fi
175
176 # Because the variable is EXPERIMENTAL_SPF and not LOOKUP_SPF we
177 # always include spf.o and compile a dummy if EXPERIMENTAL_SPF is not
178 # defined.
179
180 OBJ="${OBJ} spf.o"
181
182 # readsock is always wanted as it implements the ${readsock } expansion
183 OBJ="${OBJ} readsock.o"
184
185 echo "MODS = $MODS"
186 echo "OBJ = $OBJ"
187
188 sed -n "/$tag_marker/,\$p" < "$input"
189
190 exec >&5
191
192 # Configure-Makefile will move $target into place
193
194 # vim: set ft=sh sw=2 :